;*****************************************************************
;*  AN EPROM PROGRAMMER (MAX 128K)      BY S. SIMS    *
;*****************************************************************
	LIST P=16F887
	;CONFIG WDT=OFF 

;OBJECT OF CHIP:
;1) To program/verify/read EEPROM (preferably from a flash swf)
;2) To be able to buffer 256 bytes of RX'ed data to for "slow" pgmming
;3)cOMMANDS:
	;R0000-3FFF - READ
	;W0000-00FF -WRITE BLOCK (256 BYTES) (DOES VERIFY)
;  **NOTE: Last byte in range is written, so 0000 to 00FF will write FF
; ....so the range coudn't be 0000 to 0100 as that is more than 256!
;
;****NOTE:::must check rxusrt / reset RX bit that locks it up!

;LOWER BANK.....
INDF		EQU	0X00
TMR0		EQU	0X01
PCL		EQU	0X02
STATUS		EQU	0X03
FSR		EQU	0X04
PORTA		EQU	0X05
PORTB		EQU	0X06
PORTC		EQU	0X07
PORTD		EQU	0X08
PORTE		EQU	0X09
PCLATH		EQU	0X0A
INTCON		EQU	0X0B
PIR1		EQU	0X0C
PIR2		EQU	0X0D
TMR1L		EQU	0X0E
TMR1H		EQU	0X0F
T1CON		EQU	0X10
TMR2		EQU	0X11
T2CON		EQU	0X12
SSPBUF		EQU	0X13
SSPCON		EQU	0X14
CCPR1L		EQU	0X15
CCPR1H		EQU	0X16
CCP1CON		EQU	0X17
RCSTA		EQU	0X18
TXREG		EQU	0X19
RCREG		EQU	0X1A
CCPR2L		EQU	0X1B
CCPR2H		EQU	0X1C
CCP2CON		EQU	0X1D
ADRES		EQU	0X1E
ADCON0		EQU	0X1F
TIMER0		EQU	0X20
TIMER1		EQU	0X21
TIMER2		EQU	0X22
SSTATUS		EQU	0X23	;0=WR OR READ MODE ACTIVE
				;1=WRITE MODE
				;2=RXBUF FULL
				;3=PRG TIMING DELAY
				;4=
				;6=TX/INTRPT STOP; 7= 
TXBUF_POINTER	EQU	0X24
ADCi_CNT		EQU	0X25

MODE		EQU	0X26 ;0=MIDI PLAY(1)/STOP(0) 1=
			         ;2=
			         ;3=
			         ;4=
			         ;5=
			         ;6=
FBYTEMSB		EQU	0X27
FBYTELSB		EQU	0X28
TBYTEMSB		equ	0X29
TBYTELSB		EQU	0X2A ;0=FIRST BYTE RXED, 1=2ND BYTE RXED, 2=STOP ALL MIDI(SYSEX)
RXMSB		EQU	0X2B
RXLSB		EQU	0X2C
NONOTE_CNT		EQU	0X2D
FLICKER		EQU	0X2E
POT_FLAGS		EQU	0X2F
LAST_NOTE1		EQU	0X30 ;LAST NOTE TO CHECK AGAINST NEW TO SEE IF WAS A "BOUNCE"
LAST_VEL1		EQU	0X31 ;VELOCITY TO PUT TO NEXT NOTE IF WAS A VALID BOUNCE:		
LAST_NOTE2	EQU	0X32 ;<50mS & same note & <16vel & lastNote>31
LAST_VEL2		EQU	0X33 ;EXTRAS IN CASE MULTIPLE NOTES HIT AT SAME TIME
LAST_NOTE3	EQU	0X34
LAST_VEL3		EQU	0X35
LAST_NOTE4	EQU	0X36
LAST_VEL4		EQU	0X37

PC_FLAGS		EQU	0X38 ;** CHECK TO SEE IF NEED THIS!
SPEED		EQU	0X39 ;SPEED BUFFER TO SEND UPDATE.ISN'T SENT UNTIL CHNGED
FLASHER		EQU	0X3A
;STROBE_LEN	EQU	0X3B
ASSHOLE		EQU	0X3C ;FUCKING INC BUFFER 1 MS
ONE_TENTH	EQU	0X3D ;LED FLASHING CNT
LONG_TMR		EQU	0X3E
BOUNCE_CNT	EQU	0X3F ;CNTS (<50MS?) TIME SINCE LAST NOTE SO CAN FIX VELOCITY
SEL_LAST		EQU	0X40
SEL_TMR		EQU	0X41
SEL_NEW		EQU	0X42


BNC_PNTR		EQU	0X43
PCLATH_TEMP	EQU	0X44 ;EXCLUSIVELY FOR INTERRUPT ONLY!
STATUS_TEMP	EQU	0X45 ;EXCLUSIVELY FOR INTERRUPT ONLY!
FSR_TEMP		EQU	0X46 ;EXCLUSIVELY FOR INTERRUPT ONLY!
RX_WIDTH		EQU	0X47
XXxx		EQU	0X48
XXXxxx		EQU	0X49
PRX_STATUS	EQU	0X4A ;BITS 0-5 SET IF CORR. PRX WAS NOT CONNECTED AT POWERUP
			         ;SO USELESS TIME WASTING PTX'S AVOIDED
TOUCH_R	EQU	0X4B
TOUCH_L	EQU	0X4C


RXBUF0		EQU 	0X4D	;LEAVE A FEW ABOVE THIS FOR RX
RXBUF1		EQU 	0X4E
RXBUF2		EQU	0X4F


MIDIBUF_1		EQU	0X50 ;THESE MUST BE KEPT CLEAR FOR MIDI I/O
MIDIBUF_15		EQU	0X5F
;. . . . . 
MIDI_TX_0		EQU	0X60 ;MAX 16 BUFS FOR TX OVERFLOW


;0X70-7F AREN'T AFFECTED BY BANKS
ENC_NEW		EQU	0X72 ;LED BUFS:
ENC_TOT		EQU	0X73
ENC_TOT2		EQU	0X74
TEMP		EQU	0X75 ;
TEMP2		EQU	0X76 ;
TEMP3		EQU	0X77 ;
RX_POINTER	EQU	0X78 ;
RX_BANK		EQU	0X79 ;
MS_4		EQU	0X7A
MIDI_CHAN		EQU	0X7B ;TO PUT BACK CHANNEL FOR SEND ON, SET PC_FLAGS..
ENC_TMR		EQU	0X7C
LAST_NOTE_CNT	EQU	0X7D ;FOR NOTE OFF DELAY

W_TEMP		EQU	0X7E ;EXCLUSIVELY FOR INTERRUPT ONLY!





;----------------------------------------------

;----------------------------------------------

;----------------------------------------------						

;UPPER BANK.....
OPTION_REG	EQU	0X81

TRISA		EQU	0X85
TRISB		EQU	0X86
TRISC		EQU	0X87
TRISD		EQU	0X88
TRISE		EQU	0X89


PIE1		EQU	0X8C
PIE2		EQU	0X8D
PCON		EQU	0X8E
OSCCON		EQU	0X8F
OSCTUNE		EQU	0X90
SSPCON2		EQU	0X91
PR2		EQU	0X92
SSPADD		EQU	0X93
SSPSTAT		EQU	0X94
WPUB		EQU	0X95
OICB		EQU	0X96
VRCON		EQU	0X97
TXSTA		EQU	0X98
SPBRG		EQU	0X99
SPBRGH		EQU	0X9A
PWM1CON		EQU	0X9B
ECCPAS		EQU	0X9C
PSTRCON		EQU	0X9D
ADRESL		EQU	0X9E
ADCON1		EQU	0X9F
;MIDI PROGRAM CHANGE DATA
COM_MODE	EQU	0XA0
DASH		EQU	0XA5
;3RD BANK
WDTCON		EQU	0X105
CM1CON0		EQU	0X107
CM2CON0		EQU	0X108
CM2CON1		EQU	0X109
EEDAT		EQU	0X10C
EEADR		EQU	0X10D
EEDATH		EQU	0X10E
EEADRH		EQU	0X10F
;4TH BANK
SRCON		EQU	0X185
BAUDCTL		EQU	0X187
ANSEL		EQU	0X188
ANSELH		EQU	0X189
EECON1		EQU	0X18C
EECON2		EQU	0X18D













W_TEMPm		EQU	0XFE ;MIRROR IN CASE STATUS, 5 IS SET!!

 


;----------------------------------------------

;***eQUate bits***....__________________
;PORT C PINS
PGM		EQU	.0
OE		EQU	.1
CE		EQU	.2
VPP		EQU	.3
VCCV		EQU	.4



;TXSTA BITS
TXEN		EQU	.5
BRGH		EQU	.2	;MAY NOT USE,JUST USE BYTE
TRMT		EQU	.1
SYNC		EQU	.4

;RCSTA BITS
SPEN		EQU	.7
CREN		EQU	.4
OERR		EQU	.1


;PIR1	BITS
TMR1IF		equ	.0
TMR2IF		EQU	.1 ;SET WHEN TMR2 DONE
TXIF		EQU	.4
RCIF		EQU	.5

;SSPSTAT	
BF		EQU	.0	;BF (BUFFER FULL) BIT 0

;INTCON BITS
PEIE		EQU	.6 ;INT MASK FOR RX USART
GIE		EQU	.7 ;GLOBAL INT. ENABLE
;PIE1 BITS (INTERRUPT)
RCIE		EQU	.5






;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	ORG	0000	
                 	GOTO	START
	ORG	0004	;INTERUPT VECTOR

	MOVWF	 W_TEMP ;Copy W to TEMP register, could be bank one or zero
	SWAPF 	STATUS,W ;Swap status to be saved into W
	CLRF 	STATUS ;bank 0, regardless of current bank, Clears IRP,RP1,RP0
	MOVWF 	STATUS_TEMP ;Save status to bank zero STATUS_TEMP register
	MOVF 	PCLATH, W ;Only required if using pages 1, 2 and/or 3
	MOVWF 	PCLATH_TEMP ;Save PCLATH into W
	MOVLW	0X07
	MOVWF	PCLATH ;SET FOR JUMP HERE!(IN CASE WAS IN 0800)
	MOVF	FSR,W
	MOVWF	FSR_TEMP
	CALL	RX_GO
	
		CLRF 	STATUS
	MOVF 	PCLATH_TEMP, W ;Restore PCLATH
	MOVWF 	PCLATH ;Move W into PCLATH
	MOVF	FSR_TEMP,W
	MOVWF	FSR
	SWAPF 	STATUS_TEMP, W ;Swap STATUS_TEMP register into W
	;(sets bank to original state)
	MOVWF 	STATUS ;Move W into STATUS register
	SWAPF 	W_TEMP ;Swap W_TEMP (TO BE LAST BEFORE RETURN FRM INT)
	SWAPF 	W_TEMP,W ;Swap W_TEMP into W(swap so doesnt effect status reg!!)
	RETFIE
		
	ORG	0042
START



CLRRAM2	;CLEARS BOTH PAGES OF RAM 0020 TO 00FF
	movlw 	0x20 	;initialize pointer
	movwf 	FSR 	;to RAM
CLRRAM2LP		
	clrf 	INDF 	;clear INDF register
	BSF	FSR,7	;UPPER RAM
	CLRF	INDF
	BCF	FSR,7
	incf 	FSR	;inc pointer
	btfss 	FSR,7 	;all done?
	goto 	CLRRAM2LP 	;no, clear next BYTE
	
;	movlw 	B'01110001';OSCCON _7_ ,6= IRCF2, 5= IRCF1,4= IRCF0,3= OSTS,2= HTS,1= LTS,0= SCS
;	MOVWF	OSCCON
;------------------SETUP PORTS------------------
;
	CLRF	FSR
	clrf	PORTE
	CLRF	PORTD
	CLRF	PORTC

	CLRF	PORTB

;UPPER
	BSF	STATUS,5	;TRISES ARE IN UPPER MEM!
	MOVLW	B'11000000' ;EPROM UPPER ADDRESS LINES 
	MOVWF	TRISA	
	MOVLW	B'00000000' ;led outputs for on/read/prog
	MOVWF	TRISE
	MOVLW	B'00000000';;EPROM LOWER 8 ADDRESS LINES
	MOVWF	TRISB	
	MOVLW	B'11111111' ;0-7 EPROM DATA LINES
	MOVWF	TRISD	
	MOVLW	B'11100000' 	;C0-C4 EPROM CONTROL(SEE BITS)
	MOVWF	TRISC	;	, C6(r)&7(t)=USART
;----

	BCF	STATUS,5 ;lower ram
	CLRF	PORTC
	CLRF	PORTD 
	MOVLW	0X07
	MOVWF	PORTE
	CALL	DELAY1 ;FLASH ALL LEDS
	CLRF	PORTE	
	CALL	DELAY1 ;RED WIL COME ON BELOW
	

	BSF	STATUS,5
;-----		
	MOVLW	.51	;FOR USART BAUD RATE GEN .25 for rs232 38.4kbps
	MOVWF	SPBRG	; BAUD=9600@8MHZ
	BSF	TXSTA,BRGH	;SET HISPEED BAUD GEN
	BCF	TXSTA,SYNC	;SET TO ASYNC MODE
	MOVLW	.61
	MOVWF	PR2 ;///SET TMR2 FOR /64 (/256=/16384) BEATCOUNT	
	BCF	STATUS,5
;LOWER RAM	
;	CLRF	PORTC
;	BSF	PORTC,CSN


	BSF	RCSTA,SPEN	;SETS TO USART SERIAL PORTS
	BSF	RCSTA,CREN	;SET TO CONTIN. RX
	movlw	B'00000101' ;SETUP TMR1 MODULE FOR XXXX
	MOVWF	T1CON	;
	movlw	B'01111101' ;SETUP TMR2 MODULE
	MOVWF	T2CON	; ///as/2048 (1/4 BEAT)

;UPPER RAM
	BSF	STATUS,5
	BSF	TXSTA,TXEN ;SET USART TO TX,NEXTBYTE WRIT WILL START IT
	BCF	OPTION_REG,5	;USE TMR0 ON INTERNAL
	BSF	OPTION_REG,2	;PRESCALE /256 SO 15.625 KHZ/CNT (0-255)
	BSF	OPTION_REG,1
	BSF	OPTION_REG,0
	BCF	OPTION_REG,3	;SELECTS IN PRESCALER
	BSF	PIE1,RCIE	 ;TURN ON USART INTERUPT

	
;	MOVLW 	B'00000110'  	; Configure NO
;	MOVWF 	ADCON1 		; as anal inputs


;LOWER RAM
	BCF	STATUS,5

	MOVLW	0X07
	MOVWF	PCLATH

	MOVLW	0X60
	MOVWF	TXBUF_POINTER
	MOVLW	0Xa0
	MOVWF	RX_POINTER


	CLRF	INTCON
	BSF	INTCON,PEIE ;TURN ON EXT PIN INTERUPTS
	BSF	INTCON,GIE ;TURN ON GLOBAL INTERUPT

	BSF	PORTC,PGM
	
	BSF	PORTE,0 ;ON LED (ALSO USART ACTIVITY)





;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MAINLOOP 	NOP ;


TMR2WT	call	USARTRXQ	;CHECK RX
	call	TXQ_CALL	;ALSO FROM INTERUPT
	BTFSC	SSTATUS,2 ;CHECK IF BUFFER FULL
	GOTO	WRITE_BLOCK
	BTFSC	SSTATUS,0 ;CHECK IF READ REQUEST
	GOTO	READ_BLOCKS
	


;-------------------------1MS ROUTINES AFTER HERE-------------------------------------
TIMER_2	BTFSS	PIR1,1 ;WAIT FOR TMR2! CHANGE THIS
	GOTO	 MAINLOOP    ;SO DOES OTHER STFFTIMER_2;//
	BCF	PIR1,TMR2IF ;--->1MS
	;here every 1ms

		

MS4	INCF	MS_4 ;EVERY 4 MS
	BTFSS	MS_4,2	;>3?
	GOTO	MS4_SKIP 
	CLRF	MS_4 

;------------------------4MS ROUTINES AFTER HERE--------------------------------------
	MOVLW	0X28
	XORWF	FLASHER,W
	BTFSC	STATUS,2
	BSF	PORTE,0
	INCFSZ	FLASHER
	GOTO	MS4_SKIP
	BCF	PORTE,0 ;FLASH RED LED OFF TO SHOW WORKING(NOT HUNG UP)

	MS4_SKIP
	GOTO	MAINLOOP



;__________________________________________________________
;mainloop calls


USARTRXQ	;check for rx from pc, update motor speed, leds, etc.
	;ADD RX ERROR ROUTINE?
	BTFSS	RCSTA,OERR  ;FIRST:CHECK FOR RX USART OVERRUN ERROR
	GOTO	EVENT0
	BCF	RCSTA,CREN	;RESET RX USART
	NOP
	BSF	RCSTA,CREN
EVENT0;
;RXCHK	MOVF	MIDI_POINTER,W ;CHECK IF RX'ED DATA
;	XORLW	0X50 ;0X50 IS START POINT
;	BTFSS	STATUS,2
;	GOTO	MIDI_SORT ;UNLOAD DATA FROM 0X50++
;	GOTO	USARTRX_RET ;
USARTRX_RET
TXQX2	RETURN



TXQ_CALL	MOVF	TXBUF_POINTER,W ;**ANYTHING TO TX?
	XORLW	0X60
	BTFSC	STATUS,2
	GOTO	TXQX
	BSF	STATUS,5 ;HI -MEM
	BTFSS	TXSTA,1 ;CHECK IF TXREG EMPTY
	GOTO	TXQX
	BCF	STATUS,5

	MOVLW	0X60
	MOVWF	FSR
	MOVF	INDF,W
	MOVWF	TXREG
TXQLP	INCF	FSR
	MOVF	INDF,W
	DECF	FSR
	MOVWF	INDF
	INCF	FSR
	MOVF	FSR,W
	XORWF	TXBUF_POINTER,W
	BTFSS	STATUS,2
	GOTO	TXQLP
	DECF	TXBUF_POINTER

TXQX	BCF	STATUS,5 ;LO MEM (RAM!)
	RETURN

RX_GO	MOVF	RCREG,W
	MOVWF	TEMP
	BCF	PORTE,0 ;FLIKER ON LED OFF
	MOVF	RX_POINTER,W
	MOVWF	FSR
	MOVF	TEMP,W
	BTFSC	STATUS,2 ;IF ZERO, THEN IS A /0. PROCESS ANYWAY TO 257TH BYTE
	GOTO	HEXES
	BTFSC	SSTATUS,4 ;SET BY A CHAR> "F" (R or W)
	GOTO	CHARS
	BTFSC	SSTATUS,6 ;TOGGLE FOR 2 BYTE HEX VALUES
	GOTO	HEXLSB
HEXMSB	MOVLW	.48 ;ASCII SHIFT
	SUBWF	TEMP,W
	MOVWF	RXMSB
	MOVLW	0X47 ;CHECK IF > ASCII F, IF IS THEN IS "R" OR "W" SET FLAG
	SUBWF	TEMP,W
	BTFSC	STATUS,0
	GOTO	CHARS
	BSF	SSTATUS,6 ;TOGGLE SO NEXT BYTE RXED IS LSNIBBLE
	GOTO	INTRR1 ;EXIT UNTIL LOWER NIBBLE
HEXLSB	MOVLW	.48 ;ASCII SHIFT
	SUBWF	TEMP,W
	MOVWF	RXLSB
	BCF	SSTATUS,6
	MOVF	RXMSB,W
	CALL	HEX2BIN
	MOVWF	TEMP
	SWAPF	TEMP
	MOVF	RXLSB,W
	CALL	HEX2BIN
	IORWF	TEMP
	GOTO	HEXES

;	MOVF	RCREG,W
;	MOVWF	TEMP ;IS ABOVE 0X70 SO UNAFFECTED BY BANKS
CHARS	BSF	SSTATUS,4;FLAG SO SKIPS HEX CONVERSION UNTIL 0XAB
	
HEXES	BSF	PORTE,0 ;TURN ON ON LED
	MOVF	RX_BANK,W
	MOVWF	STATUS
	MOVF	TEMP,W
	MOVWF	INDF
	INCF	RX_POINTER
	BTFSC	RX_BANK,7
	GOTO	RX_B2CHECK
	MOVLW	0XAB ;CHECK IF A COMMAND (9BYTES+/0 or LF)
	XORWF	RX_POINTER,W
	BTFSC	STATUS,2
	GOTO	COM_CHECK
;CHECK IF BANK 1 IS DONE
COM_RET	MOVLW	0XF0
	XORWF	RX_POINTER,W
	BTFSS	STATUS,2
	GOTO	INTRR1
	MOVLW	0X10
	MOVWF	RX_POINTER
	BSF	RX_BANK,7 ;TO SET IRP
	GOTO	INTRR1

RX_B2CHECK

	MOVLW	0X70
	XORWF	RX_POINTER,W
	BTFSS	STATUS,2	
	GOTO	RX_TOPCHECK
	MOVLW	0X90
	MOVWF	RX_POINTER
	GOTO	INTRR1
RX_TOPCHECK
	MOVLW	0XE1 ;//WAS 0XE0 BUT FLASH SENDS A /0
	XORWF	RX_POINTER,W
	BTFSS	STATUS,2	
	GOTO	INTRR1
	DECF	RX_POINTER ;JUST HOLD AT END
	BSF	SSTATUS,2 ;FLAG THAT BUFFER FULL
	RETURN

COM_CHECK
	BCF	SSTATUS,4 ;RESET CHAR MODE
	BTFSC	SSTATUS,0 ;IF SET, ALREADY IN A MODE WR OR READ
	GOTO	COM_RET
	BTFSC	SSTATUS,1
	GOTO	COM_RET
	MOVLW	0XA5
	MOVWF	FSR
	MOVLW	"-"	;FIRST CHECK THERE'S A DASH
	XORWF	INDF,W
	BTFSS	STATUS,2
	GOTO	COM_RET
	MOVLW	0XA0
	MOVWF	FSR
	MOVLW	"R"
	XORWF	INDF,W
	BTFSS	STATUS,2
	GOTO	WR_CHECK
	BSF	SSTATUS,0
	GOTO	COM_RET
WR_CHECK
	MOVLW	"W"
	XORWF	INDF,W
	BTFSS	STATUS,2
	GOTO	COM_RET
	BSF	SSTATUS,1
	MOVLW	0Xa0 ;SET FOR NEW ..
	MOVWF	RX_POINTER
	CLRF	RX_BANK
	MOVLW	0XA1
	CALL	FROM_BYTE
	MOVLW	0XA6
	CALL	TO_BYTE
	GOTO	COM_RET

INTRR1	RETURN

;____________________________________________________________
;END OF MAIN LOOP CALLS



WRITE_BLOCK ;WRITE DATA UP TO RX_POINTER
	BTFSS	SSTATUS,1
	GOTO	MAINLOOP ;ABORT, COMMAND ISN'T RIGHT!

	MOVLW	0X9f ;1 LESS IS INCED BELOW
	MOVWF	FSR ;START DATA POINT
	BSF	SSTATUS,3 ;DELAY TO ALLOW VPP & VCC TO RAISE ON FIRST
WRITE_GO
	CLRF	TEMP2 ;COUNT PGM TRIES
	MOVF	FBYTELSB,W ;SET STARTING POINT (USUALLY 00)
	MOVWF	PORTB
	MOVF	FBYTEMSB,W
	ANDLW	0X3F ;SET WHICH 256 BYTE BLOCK TO PROGRAM
	MOVWF	FBYTEMSB
	MOVWF	PORTA
	BCF	PORTC,CE
	INCF	FSR
	BTFSC	STATUS,7 ;RP=1?
	GOTO	WR_RAMHI
	MOVLW	0XF0
	XORWF	FSR,W
	BTFSS	STATUS,2
	GOTO	WRITE_TRY
	MOVLW	0X10
	MOVWF	FSR
	BSF	STATUS,7 ;HI MEM
	GOTO	WRITE_TRY
WR_RAMHI	MOVLW	0X70
	XORWF	FSR,W
	BTFSS	STATUS,2
	GOTO	WRITE_TRY ;WILL END ANYWAY AT 1DF
	MOVLW	0X90
	MOVWF	FSR
	GOTO	WRITE_TRY

WRITE_TRY
	MOVLW	0X00
	BSF	STATUS,5
	MOVWF	TRISD
	BCF	STATUS,5
	MOVF	INDF,W
	MOVWF	PORTD
	BSF	PORTC,VPP ;FROM 5V TO 12.5V
	NOP
	BSF	PORTC,VCCV
	NOP
	BCF	PORTC,CE
	NOP
	BTFSC	SSTATUS,3
	CALL	DELAY2
	BCF	SSTATUS,3
	NOP
	BSF	PORTE,2;;NOP ;LIGHT YELLOW LED
	BCF	PORTC,PGM
	CALL	DELAY100
	BSF	PORTC,PGM
	BCF	PORTE,2;;NOP;TURN OF YELLOW LED
	NOP
	BSF	STATUS,5
	MOVLW	0XFF
	MOVWF	TRISD
	BCF	STATUS,5
	BCF	PORTC,OE ;NOW VERIFY
	CALL	DELAY100
	MOVF	PORTD,W
	XORWF	INDF,W
	BTFSC	STATUS,2 ;VERIFY GOOD?
	GOTO	WRITE_NEXT
	INCF	TEMP2
	BSF	PORTC,OE
	MOVLW	.10
	XORWF	TEMP2,W
	BTFSS	STATUS,2
	GOTO	WRITE_TRY	
	NOP	;ERROR, SEND WRITE ERROR MESSAGE
WRITE_DONE
	BCF	PORTC,VPP ;RETURN TO 5V
	BCF	PORTC,VCCV ;RETURN TO 5 V
	BSF	PORTC,CE
	BCF	SSTATUS,1
	BCF	SSTATUS,6
	movlw	0XA0
	MOVWF	RX_POINTER
	BCF	SSTATUS,2
	bcf	STATUS,7 ;CLR BANK SEL IN CASE
	CLRF	RX_BANK
	GOTO	MAINLOOP
WRITE_NEXT
	BSF	PORTC,OE
	clrf	 TEMP2
	MOVF	TBYTELSB,W ;CHECK AGAINST USER SET END
	XORWF	FBYTELSB,W ;ALWAYS 00 TO FF, OR 22 TO 21 SO NEVER MATCHES
	BTFSC	STATUS,2 ;UNTIL 256 BYTES. CAN BE LESS
	GOTO	WRITE_DONE
	INCFSZ	FBYTELSB
	GOTO	WRITE_GO
	INCF	FBYTEMSB	;IN CASE CROSSES A BLOCK
	GOTO	WRITE_GO	

	GOTO	MAINLOOP




FROM_BYTE ;TO SET ADDRESS ON EPROM
	MOVWF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	MOVWF	FBYTEMSB
	SWAPF	FBYTEMSB
	INCF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	IORWF	FBYTEMSB
	INCF	FSR	
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	MOVWF	FBYTELSB
	SWAPF	FBYTELSB
	INCF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	IORWF	FBYTELSB
	INCF	FSR	
	RETURN
TO_BYTE ;TO SET ADDRESS ON EPROM
	MOVWF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	MOVWF	TBYTEMSB
	SWAPF	TBYTEMSB
	INCF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	IORWF	TBYTEMSB
	INCF	FSR	
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	MOVWF	TBYTELSB
	SWAPF	TBYTELSB
	INCF	FSR
	MOVLW	.48
	SUBWF	INDF,W;GET ASCII AND CONVERT TO BIN
	CALL	HEX2BIN	
	IORWF	TBYTELSB
	INCF	FSR	
	RETURN



READ_BLOCKS
	BCF	PORTC,CE ;LOWER CE
	BCF	PORTC,OE ;LOWER OUTPUT ENABLE
	MOVLW	0XA1 ;GET LOWER UPPER LIMITS
	CALL	FROM_BYTE
	MOVLW	0XA6
	CALL	TO_BYTE
	MOVLW	0Xa0 ;SET FOR NEXT OPERATION
	MOVWF	RX_POINTER
	CLRF	RX_BANK
	BSF	STATUS,5
	MOVLW	0XFF ;SET D TO INPUT (IN CASE)
	MOVWF	TRISD
	BCF	STATUS,5

READ_LP
	MOVF	FBYTEMSB,W ;SET UPPER ADDRESS
	MOVWF	PORTA
	MOVF	FBYTELSB,W
	MOVWF	PORTB

	MOVLW	0X6E ; FOR 2 BYTES
	SUBWF	TXBUF_POINTER,W
	BTFSC	STATUS,0
	CALL	READ_WAIT
	MOVF	TXBUF_POINTER,W
	MOVWF	FSR
	MOVF	PORTD,W
	MOVWF	TEMP
	SWAPF	TEMP,W
	ANDLW	0X0F
	CALL	BIN2HEX
	MOVWF	INDF
	INCF	TXBUF_POINTER
	INCF	FSR
	MOVF	TEMP,W
	ANDLW	0X0F
	CALL	BIN2HEX
	MOVWF	INDF
	INCF	TXBUF_POINTER
	CALL	TXQ_CALL
	MOVF	FBYTELSB,W
	XORWF	TBYTELSB,W
	BTFSS	STATUS,2
	GOTO	READ_NXT
	MOVF	FBYTEMSB,W
	XORWF	TBYTEMSB,W
	BTFSS	STATUS,2
	GOTO	READ_NXT	

READ_XIT	
	BSF	PORTC,CE ;RAISE CE
	BSF	PORTC,OE ;DISABLE OUTPUT
	BCF	SSTATUS,0
	call	READ_WAIT ;NOW ADD A /0 TO END
	MOVF	TXBUF_POINTER,W
	MOVWF	FSR
	CLRF	INDF ;/0
	INCF	TXBUF_POINTER
	GOTO	MAINLOOP
READ_NXT

	INCFSZ	FBYTELSB
	GOTO	READ_LP
	INCFSZ	FBYTEMSB ;IF SKIPS THEN IS ERROR,EXIT
	GOTO	READ_LP
	GOTO	READ_XIT

READ_WAIT
	BSF	PORTE,1 ;LIGHT GREEN LED FOR READ
	CALL	TXQ_CALL	
	CALL	DELAY100
	BCF	PORTE,1 ;GREEN OFF
	MOVLW	0X6E
	SUBWF	TXBUF_POINTER,W
	BTFSC	STATUS,0
	GOTO	READ_WAIT
	RETURN








DELAY1	;1/2 SECOND DELAY
	CLRF	TIMER0
	MOVLW	0X07
DL1CUST	MOVWF	TIMER2
	MOVLW	0X18
	MOVWF	TIMER1

DELAY1LP	NOP
	NOP
	DECFSZ	TIMER0
	GOTO	DELAY1LP
	DECFSZ	TIMER1
	GOTO	DELAY1LP
	DECFSZ	TIMER2
	GOTO	DELAY1LP
	RETURN

DELAY2	
	MOVLW	0X40;NOW16MS;;MOVLW	0X04
	MOVWF	TIMER1
DL2_CUST	MOVLW	.231 ;1MS DELAY
	MOVWF	TIMER0

DL2LP	NOP
	DECFSZ	TIMER0
	GOTO	DL2LP
	DECFSZ	TIMER1
	GOTO	DL2LP	
	RETURN

	


DELAY100	MOVLW	.98 ;99.25uS DELAY**@16MHZ!
	MOVWF	TIMER0
DL100LP	NOP
	DECFSZ	TIMER0
	GOTO	DL100LP
	RETURN




	ORG	0700


BIN2BIT	ADDWF	PCL

	RETLW	B'00000001'
	RETLW	B'00000010'
	RETLW	B'00000100'
	RETLW	B'00001000'
	RETLW	B'00010000'
	RETLW	B'00100000'
	RETLW	B'01000000'
	RETLW	B'10000000'



HEX2BIN	ANDLW	0X1F
	ADDWF	PCL
	RETLW	0X00
	RETLW	0X01
	RETLW	0X02
	RETLW	0X03
	RETLW	0X04
	RETLW	0X05
	RETLW	0X06
	RETLW	0X07
	RETLW	0X08
	RETLW	0X09
	RETLW	.0
	RETLW	.0
	RETLW	.0
	RETLW	.0
	RETLW	.0
	RETLW	.0
	RETLW	.0
	RETLW	0X0A
	RETLW	0X0B
	RETLW	0X0C
	RETLW	0X0D
	RETLW	0X0E
	RETLW	0X0F
	
BIN2HEX	ANDLW	0X0F
	ADDWF	PCL
	RETLW	"0"
	RETLW	"1"
	RETLW	"2"
	RETLW	"3"
	RETLW	"4"
	RETLW	"5"
	RETLW	"6"
	RETLW	"7"
	RETLW	"8"
	RETLW	"9"
	RETLW	"A"
	RETLW	"B"
	RETLW	"C"
	RETLW	"D"
	RETLW	"E"
	RETLW	"F"

		


	END